//
// Copyright 2002, Lowell Boggs Jr.
//
// This file or directory, containing source code for a computer program,
// is Copyrighted by Lowell Boggs, Jr.  987 Regency Drive, Lewisville
// TX (USA), 75067.  You may use, copy, modify, and distribute this
// source file without charge or obligation so long as you agree to
// the following:
//
//  1.  You must indemnify Lowell Boggs against any and all financial
//      obligations caused by its use, misuse, function, or malfunction.
//      Further, you acknowledge that there is no warranty of any kind,
//      whatsoever.
//
//  2.  You agree not to attempt to patent any portion of this original
//      work -- though you may attempt to patent your own extensions to
//      it if you so choose.
//
//  3.  You keep this copyright notice with the file and all copies
//      of the file and do not change it anyway except language translation.
//
// You are responsible for enforcing your own compliance with these
// conditions and may not use this source file if you cannot agree to the
// above terms and conditions.
//
// Warning:  not all files in this directory structure are covered by the
// same copyright.  Some of them are part of the GNU source distribution
// and you must obey the GPL copyright for those files.

#ifdef _MSC_VER
#  include <io.h>
#  include <direct.h>
#  define R_OK    4       /* Test for Read permission    */
#  define W_OK    2       /* Test for Write permission   */
#  define X_OK    1       /* Test for eXecute permission */
#  define F_OK    0       /* Test for existence of File  */
#  define lstat   stat    /* no such beast on nt         */
#  define S_ISLNK(x)   0  /* ditto                       */
#  define S_IFLNK      0  /* more ditto                  */
# include <wchar.h>
# include <wtypes.h>
# include <direct.h>
# include <process.h>

#  define  SET_MODE(a,b)  setmode(a,b)


#ifndef NAME_MAX
#  define NAME_MAX 255
#endif

#define __DIRENT_COOKIE 0xfefeabab

struct dirent
{
  ino_t d_ino;                  /* unused - no equivalent on WIN32 */
  char d_name[NAME_MAX+1];
};
		
typedef struct dir_struct
{
  ULONG   dir_ulCookie;
  HANDLE  dir_hDirHandle;
  DWORD   dir_nNumFiles;
  char    dir_pDirectoryName[NAME_MAX+1];
  struct dirent dir_sdReturn;
}DIR;
					
DIR *opendir(const char *);
struct dirent *readdir(DIR *);
void closedir(DIR *);

struct passwd { char* pw_name; };

inline struct passwd* getpwuid(int) { return 0; }
							
#else
#  include <dirent.h>
#  include <unistd.h>
#  include <pwd.h>
#  include <grp.h>
#  define  O_BINARY  0 /* not needed on unix */
#  define  SET_MODE(a,b)
#endif

